commit 7ae74bd6f2ded5231e0e8c0b903a768f36e1f84f
Author: Lincoln Ramsay <lincoln.ramsay@nokia.com>
Date:   Mon May 24 14:48:10 2010 +1000

    extra const-ness
---
 src/sensors/qaccelerometer.cpp      |    2 +-
 src/sensors/qaccelerometer.h        |    2 +-
 src/sensors/qambientlightsensor.cpp |    2 +-
 src/sensors/qambientlightsensor.h   |    2 +-
 src/sensors/qcompass.cpp            |    2 +-
 src/sensors/qcompass.h              |    2 +-
 src/sensors/qmagnetometer.cpp       |    2 +-
 src/sensors/qmagnetometer.h         |    2 +-
 src/sensors/qorientationsensor.cpp  |    2 +-
 src/sensors/qorientationsensor.h    |    2 +-
 src/sensors/qproximitysensor.cpp    |    2 +-
 src/sensors/qproximitysensor.h      |    2 +-
 src/sensors/qrotationsensor.cpp     |    2 +-
 src/sensors/qrotationsensor.h       |    2 +-
 src/sensors/qtapsensor.cpp          |    2 +-
 src/sensors/qtapsensor.h            |    2 +-
 16 files changed, 16 insertions(+), 16 deletions(-)

diff --git a/src/sensors/qaccelerometer.cpp b/src/sensors/qaccelerometer.cpp
index cd396fe..d022e28 100644
--- a/src/sensors/qaccelerometer.cpp
+++ b/src/sensors/qaccelerometer.cpp
@@ -148,7 +148,7 @@ void QAccelerometerReading::setZ(qreal z)
     \sa QSensorFilter::filter()
 */
 
-const char *QAccelerometer::type("QAccelerometer");
+char const * const QAccelerometer::type("QAccelerometer");
 
 /*!
     \class QAccelerometer
diff --git a/src/sensors/qaccelerometer.h b/src/sensors/qaccelerometer.h
index 34b9b87..e8d942e 100644
--- a/src/sensors/qaccelerometer.h
+++ b/src/sensors/qaccelerometer.h
@@ -81,7 +81,7 @@ public:
     explicit QAccelerometer(QObject *parent = 0) : QSensor(QAccelerometer::type, parent) {}
     virtual ~QAccelerometer() {}
     QAccelerometerReading *reading() const { return static_cast<QAccelerometerReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qambientlightsensor.cpp b/src/sensors/qambientlightsensor.cpp
index ede75d4..563ec4b 100644
--- a/src/sensors/qambientlightsensor.cpp
+++ b/src/sensors/qambientlightsensor.cpp
@@ -113,7 +113,7 @@ void QAmbientLightReading::setLightLevel(QAmbientLightReading::LightLevel lightL
     \sa QSensorFilter::filter()
 */
 
-const char *QAmbientLightSensor::type("QAmbientLightSensor");
+char const * const QAmbientLightSensor::type("QAmbientLightSensor");
 
 /*!
     \class QAmbientLightSensor
diff --git a/src/sensors/qambientlightsensor.h b/src/sensors/qambientlightsensor.h
index f886018..6953fd8 100644
--- a/src/sensors/qambientlightsensor.h
+++ b/src/sensors/qambientlightsensor.h
@@ -83,7 +83,7 @@ public:
     explicit QAmbientLightSensor(QObject *parent = 0) : QSensor(QAmbientLightSensor::type, parent) {}
     virtual ~QAmbientLightSensor() {}
     QAmbientLightReading *reading() const { return static_cast<QAmbientLightReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qcompass.cpp b/src/sensors/qcompass.cpp
index 1c17101..ba8dc41 100644
--- a/src/sensors/qcompass.cpp
+++ b/src/sensors/qcompass.cpp
@@ -133,7 +133,7 @@ void QCompassReading::setCalibrationLevel(qreal calibrationLevel)
     \sa QSensorFilter::filter()
 */
 
-const char *QCompass::type("QCompass");
+char const * const QCompass::type("QCompass");
 
 /*!
     \class QCompass
diff --git a/src/sensors/qcompass.h b/src/sensors/qcompass.h
index 962fb01..86c95f5 100644
--- a/src/sensors/qcompass.h
+++ b/src/sensors/qcompass.h
@@ -77,7 +77,7 @@ public:
     explicit QCompass(QObject *parent = 0) : QSensor(QCompass::type, parent) {}
     virtual ~QCompass() {}
     QCompassReading *reading() const { return static_cast<QCompassReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qmagnetometer.cpp b/src/sensors/qmagnetometer.cpp
index c141615..84031bf 100644
--- a/src/sensors/qmagnetometer.cpp
+++ b/src/sensors/qmagnetometer.cpp
@@ -185,7 +185,7 @@ void QMagnetometerReading::setCalibrationLevel(qreal calibrationLevel)
     \sa QSensorFilter::filter()
 */
 
-const char *QMagnetometer::type("QMagnetometer");
+char const * const QMagnetometer::type("QMagnetometer");
 
 /*!
     \class QMagnetometer
diff --git a/src/sensors/qmagnetometer.h b/src/sensors/qmagnetometer.h
index 828a12e..01a80e5 100644
--- a/src/sensors/qmagnetometer.h
+++ b/src/sensors/qmagnetometer.h
@@ -91,7 +91,7 @@ public:
     explicit QMagnetometer(QObject *parent = 0) : QSensor(QMagnetometer::type, parent) {}
     virtual ~QMagnetometer() {}
     QMagnetometerReading *reading() const { return static_cast<QMagnetometerReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qorientationsensor.cpp b/src/sensors/qorientationsensor.cpp
index d03843f..2ce9200 100644
--- a/src/sensors/qorientationsensor.cpp
+++ b/src/sensors/qorientationsensor.cpp
@@ -122,7 +122,7 @@ void QOrientationReading::setOrientation(QOrientationReading::Orientation orient
     \sa QSensorFilter::filter()
 */
 
-const char *QOrientationSensor::type("QOrientationSensor");
+char const * const QOrientationSensor::type("QOrientationSensor");
 
 /*!
     \class QOrientationSensor
diff --git a/src/sensors/qorientationsensor.h b/src/sensors/qorientationsensor.h
index b2a6db9..8ed65ec 100644
--- a/src/sensors/qorientationsensor.h
+++ b/src/sensors/qorientationsensor.h
@@ -84,7 +84,7 @@ public:
     explicit QOrientationSensor(QObject *parent = 0) : QSensor(QOrientationSensor::type, parent) {}
     virtual ~QOrientationSensor() {}
     QOrientationReading *reading() const { return static_cast<QOrientationReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qproximitysensor.cpp b/src/sensors/qproximitysensor.cpp
index 2818437..023356f 100644
--- a/src/sensors/qproximitysensor.cpp
+++ b/src/sensors/qproximitysensor.cpp
@@ -103,7 +103,7 @@ void QProximityReading::setClose(bool close)
     \sa QSensorFilter::filter()
 */
 
-const char *QProximitySensor::type("QProximitySensor");
+char const * const QProximitySensor::type("QProximitySensor");
 
 /*!
     \class QProximitySensor
diff --git a/src/sensors/qproximitysensor.h b/src/sensors/qproximitysensor.h
index 6379b28..4f84e13 100644
--- a/src/sensors/qproximitysensor.h
+++ b/src/sensors/qproximitysensor.h
@@ -73,7 +73,7 @@ public:
     explicit QProximitySensor(QObject *parent = 0) : QSensor(QProximitySensor::type, parent) {}
     virtual ~QProximitySensor() {}
     QProximityReading *reading() const { return static_cast<QProximityReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qrotationsensor.cpp b/src/sensors/qrotationsensor.cpp
index 899af13..2d7df0f 100644
--- a/src/sensors/qrotationsensor.cpp
+++ b/src/sensors/qrotationsensor.cpp
@@ -184,7 +184,7 @@ void QRotationReading::setZ(qreal z)
     \sa QSensorFilter::filter()
 */
 
-const char *QRotationSensor::type("QRotationSensor");
+char const * const QRotationSensor::type("QRotationSensor");
 
 /*!
     \class QRotationSensor
diff --git a/src/sensors/qrotationsensor.h b/src/sensors/qrotationsensor.h
index 887d3c9..1d4a996 100644
--- a/src/sensors/qrotationsensor.h
+++ b/src/sensors/qrotationsensor.h
@@ -84,7 +84,7 @@ public:
     explicit QRotationSensor(QObject *parent = 0) : QSensor(QRotationSensor::type, parent) {}
     virtual ~QRotationSensor() {}
     QRotationReading *reading() const { return static_cast<QRotationReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE
diff --git a/src/sensors/qtapsensor.cpp b/src/sensors/qtapsensor.cpp
index 666af08..0a461d7 100644
--- a/src/sensors/qtapsensor.cpp
+++ b/src/sensors/qtapsensor.cpp
@@ -145,7 +145,7 @@ void QTapReading::setDoubleTap(bool doubleTap)
     \sa QSensorFilter::filter()
 */
 
-const char *QTapSensor::type("QTapSensor");
+char const * const QTapSensor::type("QTapSensor");
 
 /*!
     \class QTapSensor
diff --git a/src/sensors/qtapsensor.h b/src/sensors/qtapsensor.h
index b27f2dd..2b36c29 100644
--- a/src/sensors/qtapsensor.h
+++ b/src/sensors/qtapsensor.h
@@ -94,7 +94,7 @@ public:
     explicit QTapSensor(QObject *parent = 0) : QSensor(QTapSensor::type, parent) {}
     virtual ~QTapSensor() {}
     QTapReading *reading() const { return static_cast<QTapReading*>(QSensor::reading()); }
-    static const char *type;
+    static char const * const type;
 };
 
 QTM_END_NAMESPACE